
Ruby - Bug #19754

`IO::Buffer#get_string` raises unsuitable exception for too large offset

07/03/2023 10:48 AM - nobu (Nobuyoshi Nakada)

Status: Closed   

Priority: Normal   

Assignee: ioquatix (Samuel Williams)   

Target version:    

ruby -v:  Backport: 3.0: DONTNEED, 3.1: DONE, 3.2:

DONE

Description

The message seems suitable when both of offset and length are given.

IO::Buffer.for("test").get_string(5, 0) 

#=> Specified offset+length exceeds buffer size! (ArgumentError)

 But without length, it doesn't seem to check offset properly.

IO::Buffer.for("test").get_string(5) #=> negative string size (or size too big) (ArgumentError)

 https://github.com/ruby/ruby/pull/8016

Associated revisions

Revision 19346c2336053b351673da030b00c704138252d8 - 09/12/2023 09:45 PM - nobu (Nobuyoshi Nakada)

[Bug #19754] Make IO::Buffer#get_string check offset range (#8016)

Revision 19346c2336053b351673da030b00c704138252d8 - 09/12/2023 09:45 PM - nobu (Nobuyoshi Nakada)

[Bug #19754] Make IO::Buffer#get_string check offset range (#8016)

Revision 19346c23 - 09/12/2023 09:45 PM - nobu (Nobuyoshi Nakada)

[Bug #19754] Make IO::Buffer#get_string check offset range (#8016)

Revision 8bbf909bb561732057b533cee1618b14886e07ba - 10/28/2023 02:57 AM - nagachika (Tomoyuki Chikanaga)

merge revision(s) 19346c2336053b351673da030b00c704138252d8: [Backport #19754]

    [Bug #19754] Make `IO::Buffer#get_string` check `offset` range

     (#8016)

    ---

     io_buffer.c                 | 3 +++

     test/ruby/test_io_buffer.rb | 8 ++++++++

     2 files changed, 11 insertions(+)

Revision 8bbf909bb561732057b533cee1618b14886e07ba - 10/28/2023 02:57 AM - nagachika (Tomoyuki Chikanaga)

merge revision(s) 19346c2336053b351673da030b00c704138252d8: [Backport #19754]

    [Bug #19754] Make `IO::Buffer#get_string` check `offset` range

     (#8016)

    ---

     io_buffer.c                 | 3 +++

     test/ruby/test_io_buffer.rb | 8 ++++++++

     2 files changed, 11 insertions(+)

Revision 8bbf909b - 10/28/2023 02:57 AM - nagachika (Tomoyuki Chikanaga)

merge revision(s) 19346c2336053b351673da030b00c704138252d8: [Backport #19754]

    [Bug #19754] Make `IO::Buffer#get_string` check `offset` range

     (#8016)
    ---

     io_buffer.c                 | 3 +++

     test/ruby/test_io_buffer.rb | 8 ++++++++

     2 files changed, 11 insertions(+)

Revision 4f7b595815bd75706c276b03c8d445748e869f2e - 11/06/2023 11:18 AM - U.Nakamura 

merge revision(s) 19346c2336053b351673da030b00c704138252d8: [Backport #19754]

    [Bug #19754] Make `IO::Buffer#get_string` check `offset` range

     (#8016)

    ---

     io_buffer.c                 | 3 +++

     test/ruby/test_io_buffer.rb | 8 ++++++++

     2 files changed, 11 insertions(+)

Revision 4f7b595815bd75706c276b03c8d445748e869f2e - 11/06/2023 11:18 AM - U.Nakamura 

merge revision(s) 19346c2336053b351673da030b00c704138252d8: [Backport #19754]

    [Bug #19754] Make `IO::Buffer#get_string` check `offset` range

     (#8016)

    ---

     io_buffer.c                 | 3 +++

     test/ruby/test_io_buffer.rb | 8 ++++++++

     2 files changed, 11 insertions(+)

Revision 4f7b5958 - 11/06/2023 11:18 AM - U.Nakamura 

merge revision(s) 19346c2336053b351673da030b00c704138252d8: [Backport #19754]

    [Bug #19754] Make `IO::Buffer#get_string` check `offset` range

     (#8016)

    ---

     io_buffer.c                 | 3 +++

     test/ruby/test_io_buffer.rb | 8 ++++++++

     2 files changed, 11 insertions(+)

History

#1 - 07/03/2023 11:02 AM - nobu (Nobuyoshi Nakada)

- Description updated

#2 - 07/03/2023 11:03 AM - nobu (Nobuyoshi Nakada)

- Backport changed from 3.0: UNKNOWN, 3.1: UNKNOWN, 3.2: UNKNOWN to 3.0: DONTNEED, 3.1: REQUIRED, 3.2: REQUIRED

#3 - 09/12/2023 05:27 AM - nobu (Nobuyoshi Nakada)

- Status changed from Open to Assigned

- Assignee set to ioquatix (Samuel Williams)

#4 - 09/12/2023 09:45 PM - nobu (Nobuyoshi Nakada)

- Status changed from Assigned to Closed

Applied in changeset git|19346c2336053b351673da030b00c704138252d8.

[Bug #19754] Make IO::Buffer#get_string check offset range (#8016)

#5 - 09/13/2023 09:44 AM - ioquatix (Samuel Williams)

This change isn't sufficient, it just protects against the invalid value of offset. We can backport it, but I don't feel strongly about whether it's required or

not.

#6 - 09/13/2023 09:44 AM - ioquatix (Samuel Williams)

It also begs the question whether NUM2SIZET should allow negative values..
#7 - 10/28/2023 03:20 AM - nagachika (Tomoyuki Chikanaga)

- Backport changed from 3.0: DONTNEED, 3.1: REQUIRED, 3.2: REQUIRED to 3.0: DONTNEED, 3.1: REQUIRED, 3.2: DONE

ruby_3_2 8bbf909bb561732057b533cee1618b14886e07ba merged revision(s) 19346c2336053b351673da030b00c704138252d8.

#8 - 11/06/2023 11:18 AM - usa (Usaku NAKAMURA)

- Backport changed from 3.0: DONTNEED, 3.1: REQUIRED, 3.2: DONE to 3.0: DONTNEED, 3.1: DONE, 3.2: DONE

ruby_3_1 4f7b595815bd75706c276b03c8d445748e869f2e merged revision(s) 19346c2336053b351673da030b00c704138252d8.

#9 - 11/06/2023 11:41 AM - ioquatix (Samuel Williams)

Thanks!
